/* fuzzy_matching.c generated by valac 0.56.17, the Vala compiler
 * generated from fuzzy_matching.vala, do not modify */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

VALA_EXTERN gint util_search_distance (const gchar* item,
                           const gchar* query);
VALA_EXTERN gint util_damerau_levenshtein_distance (const gchar* source,
                                        const gchar* target,
                                        gint insert_cost,
                                        gint delete_cost,
                                        gint replace_cost,
                                        gint swap_cost);
static gint* _int_dup (gint* self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

gint
util_search_distance (const gchar* item,
                      const gchar* query)
{
	gchar** words = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint words_length1;
	gint _words_size_;
	gchar** query_words = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint query_words_length1;
	gint _query_words_size_;
	gint base_distance = 0;
	gint min_word = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gint result;
#line 5 "../lib/util/fuzzy_matching.vala"
	g_return_val_if_fail (item != NULL, 0);
#line 5 "../lib/util/fuzzy_matching.vala"
	g_return_val_if_fail (query != NULL, 0);
#line 6 "../lib/util/fuzzy_matching.vala"
	_tmp1_ = _tmp0_ = g_strsplit_set (item, " _-", 0);
#line 6 "../lib/util/fuzzy_matching.vala"
	words = _tmp1_;
#line 6 "../lib/util/fuzzy_matching.vala"
	words_length1 = _vala_array_length (_tmp0_);
#line 6 "../lib/util/fuzzy_matching.vala"
	_words_size_ = words_length1;
#line 7 "../lib/util/fuzzy_matching.vala"
	_tmp3_ = _tmp2_ = g_strsplit_set (query, " _-", 0);
#line 7 "../lib/util/fuzzy_matching.vala"
	query_words = _tmp3_;
#line 7 "../lib/util/fuzzy_matching.vala"
	query_words_length1 = _vala_array_length (_tmp2_);
#line 7 "../lib/util/fuzzy_matching.vala"
	_query_words_size_ = query_words_length1;
#line 8 "../lib/util/fuzzy_matching.vala"
	base_distance = 0;
#line 9 "../lib/util/fuzzy_matching.vala"
	min_word = G_MAXINT;
#line 10 "../lib/util/fuzzy_matching.vala"
	_tmp4_ = words;
#line 10 "../lib/util/fuzzy_matching.vala"
	_tmp4__length1 = words_length1;
#line 98 "fuzzy_matching.c"
	{
		gchar** i_collection = NULL;
		gint i_collection_length1 = 0;
		gint _i_collection_size_ = 0;
		gint i_it = 0;
#line 10 "../lib/util/fuzzy_matching.vala"
		i_collection = _tmp4_;
#line 10 "../lib/util/fuzzy_matching.vala"
		i_collection_length1 = _tmp4__length1;
#line 10 "../lib/util/fuzzy_matching.vala"
		for (i_it = 0; i_it < i_collection_length1; i_it = i_it + 1) {
#line 110 "fuzzy_matching.c"
			gchar* _tmp5_;
			gchar* i = NULL;
#line 10 "../lib/util/fuzzy_matching.vala"
			_tmp5_ = g_strdup (i_collection[i_it]);
#line 10 "../lib/util/fuzzy_matching.vala"
			i = _tmp5_;
#line 117 "fuzzy_matching.c"
			{
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint min = 0;
				gchar** _tmp9_;
				gint _tmp9__length1;
#line 11 "../lib/util/fuzzy_matching.vala"
				_tmp6_ = i;
#line 11 "../lib/util/fuzzy_matching.vala"
				_tmp7_ = strlen (_tmp6_);
#line 11 "../lib/util/fuzzy_matching.vala"
				_tmp8_ = _tmp7_;
#line 11 "../lib/util/fuzzy_matching.vala"
				if (_tmp8_ == 0) {
#line 11 "../lib/util/fuzzy_matching.vala"
					_g_free0 (i);
#line 11 "../lib/util/fuzzy_matching.vala"
					continue;
#line 137 "fuzzy_matching.c"
				}
#line 12 "../lib/util/fuzzy_matching.vala"
				min = G_MAXINT;
#line 13 "../lib/util/fuzzy_matching.vala"
				_tmp9_ = query_words;
#line 13 "../lib/util/fuzzy_matching.vala"
				_tmp9__length1 = query_words_length1;
#line 145 "fuzzy_matching.c"
				{
					gchar** q_collection = NULL;
					gint q_collection_length1 = 0;
					gint _q_collection_size_ = 0;
					gint q_it = 0;
#line 13 "../lib/util/fuzzy_matching.vala"
					q_collection = _tmp9_;
#line 13 "../lib/util/fuzzy_matching.vala"
					q_collection_length1 = _tmp9__length1;
#line 13 "../lib/util/fuzzy_matching.vala"
					for (q_it = 0; q_it < q_collection_length1; q_it = q_it + 1) {
#line 157 "fuzzy_matching.c"
						gchar* _tmp10_;
						gchar* q = NULL;
#line 13 "../lib/util/fuzzy_matching.vala"
						_tmp10_ = g_strdup (q_collection[q_it]);
#line 13 "../lib/util/fuzzy_matching.vala"
						q = _tmp10_;
#line 164 "fuzzy_matching.c"
						{
							const gchar* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
#line 14 "../lib/util/fuzzy_matching.vala"
							_tmp11_ = q;
#line 14 "../lib/util/fuzzy_matching.vala"
							_tmp12_ = strlen (_tmp11_);
#line 14 "../lib/util/fuzzy_matching.vala"
							_tmp13_ = _tmp12_;
#line 14 "../lib/util/fuzzy_matching.vala"
							if (_tmp13_ == 0) {
#line 14 "../lib/util/fuzzy_matching.vala"
								_g_free0 (q);
#line 14 "../lib/util/fuzzy_matching.vala"
								continue;
#line 183 "fuzzy_matching.c"
							}
#line 15 "../lib/util/fuzzy_matching.vala"
							_tmp14_ = i;
#line 15 "../lib/util/fuzzy_matching.vala"
							_tmp15_ = q;
#line 15 "../lib/util/fuzzy_matching.vala"
							min = MIN (min, util_damerau_levenshtein_distance (_tmp14_, _tmp15_, 5, 3, 2, 1));
#line 13 "../lib/util/fuzzy_matching.vala"
							_g_free0 (q);
#line 193 "fuzzy_matching.c"
						}
					}
				}
#line 17 "../lib/util/fuzzy_matching.vala"
				base_distance += min;
#line 18 "../lib/util/fuzzy_matching.vala"
				min_word = MIN (min_word, min);
#line 10 "../lib/util/fuzzy_matching.vala"
				_g_free0 (i);
#line 203 "fuzzy_matching.c"
			}
		}
	}
#line 20 "../lib/util/fuzzy_matching.vala"
	_tmp16_ = words;
#line 20 "../lib/util/fuzzy_matching.vala"
	_tmp16__length1 = words_length1;
#line 20 "../lib/util/fuzzy_matching.vala"
	result = ((base_distance + min_word) / _tmp16__length1) / 2;
#line 20 "../lib/util/fuzzy_matching.vala"
	query_words = (_vala_array_free (query_words, query_words_length1, (GDestroyNotify) g_free), NULL);
#line 20 "../lib/util/fuzzy_matching.vala"
	words = (_vala_array_free (words, words_length1, (GDestroyNotify) g_free), NULL);
#line 20 "../lib/util/fuzzy_matching.vala"
	return result;
#line 219 "fuzzy_matching.c"
}

/**
 * This implementation is an adaptation based on Kevin L. Stern's work
 * https://github.com/KevinStern/software-and-algorithms
 *
 * The running time of the Damerau-Levenshtein algorithm is O(n*m) where n is
 * the length of the source string and m is the length of the target string.
 * This implementation consumes O(n*m) space.
 */
static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 44 "../lib/util/fuzzy_matching.vala"
	dup = g_new0 (gint, 1);
#line 44 "../lib/util/fuzzy_matching.vala"
	memcpy (dup, self, sizeof (gint));
#line 44 "../lib/util/fuzzy_matching.vala"
	return dup;
#line 240 "fuzzy_matching.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 44 "../lib/util/fuzzy_matching.vala"
	return self ? _int_dup (self) : NULL;
#line 248 "fuzzy_matching.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 262 "fuzzy_matching.c"
}

gint
util_damerau_levenshtein_distance (const gchar* source,
                                   const gchar* target,
                                   gint insert_cost,
                                   gint delete_cost,
                                   gint replace_cost,
                                   gint swap_cost)
{
	gint delete_distance = 0;
	gint insert_distance = 0;
	gint match_distance = 0;
	gint jSwap = 0;
	gint maxSourceLetterMatchIndex = 0;
	gint* candidateSwapIndex = NULL;
	gint _tmp0_;
	gint* _tmp1_;
	gint swap_distance = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp6_;
	gint _tmp7_;
	gint* table = NULL;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint* _tmp14_;
	gint table_length1;
	gint table_length2;
	GeeHashMap* sourceIndexByCharacter = NULL;
	GeeHashMap* _tmp15_;
	GeeHashMap* _tmp17_;
	gint* _tmp61_;
	gint _tmp61__length1;
	gint _tmp61__length2;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	gint result;
#line 31 "../lib/util/fuzzy_matching.vala"
	g_return_val_if_fail (source != NULL, 0);
#line 31 "../lib/util/fuzzy_matching.vala"
	g_return_val_if_fail (target != NULL, 0);
#line 39 "../lib/util/fuzzy_matching.vala"
	delete_distance = 0;
#line 40 "../lib/util/fuzzy_matching.vala"
	insert_distance = 0;
#line 41 "../lib/util/fuzzy_matching.vala"
	match_distance = 0;
#line 42 "../lib/util/fuzzy_matching.vala"
	jSwap = 0;
#line 43 "../lib/util/fuzzy_matching.vala"
	maxSourceLetterMatchIndex = 0;
#line 44 "../lib/util/fuzzy_matching.vala"
	_tmp0_ = 0;
#line 44 "../lib/util/fuzzy_matching.vala"
	_tmp1_ = __int_dup0 (&_tmp0_);
#line 44 "../lib/util/fuzzy_matching.vala"
	candidateSwapIndex = _tmp1_;
#line 45 "../lib/util/fuzzy_matching.vala"
	swap_distance = 0;
#line 47 "../lib/util/fuzzy_matching.vala"
	_tmp2_ = strlen (source);
#line 47 "../lib/util/fuzzy_matching.vala"
	_tmp3_ = _tmp2_;
#line 47 "../lib/util/fuzzy_matching.vala"
	if (_tmp3_ == 0) {
#line 334 "fuzzy_matching.c"
		gint _tmp4_;
		gint _tmp5_;
#line 48 "../lib/util/fuzzy_matching.vala"
		_tmp4_ = strlen (target);
#line 48 "../lib/util/fuzzy_matching.vala"
		_tmp5_ = _tmp4_;
#line 48 "../lib/util/fuzzy_matching.vala"
		result = _tmp5_ * insert_cost;
#line 48 "../lib/util/fuzzy_matching.vala"
		_g_free0 (candidateSwapIndex);
#line 48 "../lib/util/fuzzy_matching.vala"
		return result;
#line 347 "fuzzy_matching.c"
	}
#line 50 "../lib/util/fuzzy_matching.vala"
	_tmp6_ = strlen (target);
#line 50 "../lib/util/fuzzy_matching.vala"
	_tmp7_ = _tmp6_;
#line 50 "../lib/util/fuzzy_matching.vala"
	if (_tmp7_ == 0) {
#line 355 "fuzzy_matching.c"
		gint _tmp8_;
		gint _tmp9_;
#line 51 "../lib/util/fuzzy_matching.vala"
		_tmp8_ = strlen (source);
#line 51 "../lib/util/fuzzy_matching.vala"
		_tmp9_ = _tmp8_;
#line 51 "../lib/util/fuzzy_matching.vala"
		result = _tmp9_ * delete_cost;
#line 51 "../lib/util/fuzzy_matching.vala"
		_g_free0 (candidateSwapIndex);
#line 51 "../lib/util/fuzzy_matching.vala"
		return result;
#line 368 "fuzzy_matching.c"
	}
#line 53 "../lib/util/fuzzy_matching.vala"
	_tmp10_ = strlen (source);
#line 53 "../lib/util/fuzzy_matching.vala"
	_tmp11_ = _tmp10_;
#line 53 "../lib/util/fuzzy_matching.vala"
	_tmp12_ = strlen (target);
#line 53 "../lib/util/fuzzy_matching.vala"
	_tmp13_ = _tmp12_;
#line 53 "../lib/util/fuzzy_matching.vala"
	_tmp14_ = g_new0 (gint, _tmp11_ * _tmp13_);
#line 53 "../lib/util/fuzzy_matching.vala"
	table = _tmp14_;
#line 53 "../lib/util/fuzzy_matching.vala"
	table_length1 = _tmp11_;
#line 53 "../lib/util/fuzzy_matching.vala"
	table_length2 = _tmp13_;
#line 54 "../lib/util/fuzzy_matching.vala"
	_tmp15_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "../lib/util/fuzzy_matching.vala"
	sourceIndexByCharacter = _tmp15_;
#line 56 "../lib/util/fuzzy_matching.vala"
	if (string_get_char (source, (glong) 0) != string_get_char (target, (glong) 0)) {
#line 392 "fuzzy_matching.c"
		gint* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
#line 57 "../lib/util/fuzzy_matching.vala"
		_tmp16_ = table;
#line 57 "../lib/util/fuzzy_matching.vala"
		_tmp16__length1 = table_length1;
#line 57 "../lib/util/fuzzy_matching.vala"
		_tmp16__length2 = table_length2;
#line 57 "../lib/util/fuzzy_matching.vala"
		_tmp16_[(0 * _tmp16__length2) + 0] = MIN (replace_cost, delete_cost + insert_cost);
#line 404 "fuzzy_matching.c"
	}
#line 59 "../lib/util/fuzzy_matching.vala"
	_tmp17_ = sourceIndexByCharacter;
#line 59 "../lib/util/fuzzy_matching.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, (gpointer) ((gintptr) string_get_char (source, (glong) 0)), (gpointer) ((gintptr) 0));
#line 410 "fuzzy_matching.c"
	{
		gint i = 0;
#line 61 "../lib/util/fuzzy_matching.vala"
		i = 1;
#line 415 "fuzzy_matching.c"
		{
			gboolean _tmp18_ = FALSE;
#line 61 "../lib/util/fuzzy_matching.vala"
			_tmp18_ = TRUE;
#line 61 "../lib/util/fuzzy_matching.vala"
			while (TRUE) {
#line 422 "fuzzy_matching.c"
				gint _tmp20_;
				gint _tmp21_;
				gint* _tmp22_;
				gint _tmp22__length1;
				gint _tmp22__length2;
				gint _tmp23_;
				gint _tmp24_ = 0;
				gint* _tmp25_;
				gint _tmp25__length1;
				gint _tmp25__length2;
#line 61 "../lib/util/fuzzy_matching.vala"
				if (!_tmp18_) {
#line 435 "fuzzy_matching.c"
					gint _tmp19_;
#line 61 "../lib/util/fuzzy_matching.vala"
					_tmp19_ = i;
#line 61 "../lib/util/fuzzy_matching.vala"
					i = _tmp19_ + 1;
#line 441 "fuzzy_matching.c"
				}
#line 61 "../lib/util/fuzzy_matching.vala"
				_tmp18_ = FALSE;
#line 61 "../lib/util/fuzzy_matching.vala"
				_tmp20_ = strlen (source);
#line 61 "../lib/util/fuzzy_matching.vala"
				_tmp21_ = _tmp20_;
#line 61 "../lib/util/fuzzy_matching.vala"
				if (!(i < _tmp21_)) {
#line 61 "../lib/util/fuzzy_matching.vala"
					break;
#line 453 "fuzzy_matching.c"
				}
#line 62 "../lib/util/fuzzy_matching.vala"
				_tmp22_ = table;
#line 62 "../lib/util/fuzzy_matching.vala"
				_tmp22__length1 = table_length1;
#line 62 "../lib/util/fuzzy_matching.vala"
				_tmp22__length2 = table_length2;
#line 62 "../lib/util/fuzzy_matching.vala"
				_tmp23_ = _tmp22_[((i - 1) * _tmp22__length2) + 0];
#line 62 "../lib/util/fuzzy_matching.vala"
				delete_distance = _tmp23_ + delete_cost;
#line 63 "../lib/util/fuzzy_matching.vala"
				insert_distance = ((i + 1) * delete_cost) + insert_cost;
#line 64 "../lib/util/fuzzy_matching.vala"
				if (string_get_char (source, (glong) i) == string_get_char (target, (glong) 0)) {
#line 64 "../lib/util/fuzzy_matching.vala"
					_tmp24_ = 0;
#line 471 "fuzzy_matching.c"
				} else {
#line 64 "../lib/util/fuzzy_matching.vala"
					_tmp24_ = replace_cost;
#line 475 "fuzzy_matching.c"
				}
#line 64 "../lib/util/fuzzy_matching.vala"
				match_distance = (i * delete_cost) + _tmp24_;
#line 65 "../lib/util/fuzzy_matching.vala"
				_tmp25_ = table;
#line 65 "../lib/util/fuzzy_matching.vala"
				_tmp25__length1 = table_length1;
#line 65 "../lib/util/fuzzy_matching.vala"
				_tmp25__length2 = table_length2;
#line 65 "../lib/util/fuzzy_matching.vala"
				_tmp25_[(i * _tmp25__length2) + 0] = MIN (MIN (delete_distance, insert_distance), match_distance);
#line 487 "fuzzy_matching.c"
			}
		}
	}
	{
		gint j = 0;
#line 68 "../lib/util/fuzzy_matching.vala"
		j = 1;
#line 495 "fuzzy_matching.c"
		{
			gboolean _tmp26_ = FALSE;
#line 68 "../lib/util/fuzzy_matching.vala"
			_tmp26_ = TRUE;
#line 68 "../lib/util/fuzzy_matching.vala"
			while (TRUE) {
#line 502 "fuzzy_matching.c"
				gint _tmp28_;
				gint _tmp29_;
				gint* _tmp30_;
				gint _tmp30__length1;
				gint _tmp30__length2;
				gint _tmp31_;
				gint _tmp32_ = 0;
				gint* _tmp33_;
				gint _tmp33__length1;
				gint _tmp33__length2;
#line 68 "../lib/util/fuzzy_matching.vala"
				if (!_tmp26_) {
#line 515 "fuzzy_matching.c"
					gint _tmp27_;
#line 68 "../lib/util/fuzzy_matching.vala"
					_tmp27_ = j;
#line 68 "../lib/util/fuzzy_matching.vala"
					j = _tmp27_ + 1;
#line 521 "fuzzy_matching.c"
				}
#line 68 "../lib/util/fuzzy_matching.vala"
				_tmp26_ = FALSE;
#line 68 "../lib/util/fuzzy_matching.vala"
				_tmp28_ = strlen (target);
#line 68 "../lib/util/fuzzy_matching.vala"
				_tmp29_ = _tmp28_;
#line 68 "../lib/util/fuzzy_matching.vala"
				if (!(j < _tmp29_)) {
#line 68 "../lib/util/fuzzy_matching.vala"
					break;
#line 533 "fuzzy_matching.c"
				}
#line 69 "../lib/util/fuzzy_matching.vala"
				delete_distance = ((j + 1) * insert_cost) + delete_cost;
#line 70 "../lib/util/fuzzy_matching.vala"
				_tmp30_ = table;
#line 70 "../lib/util/fuzzy_matching.vala"
				_tmp30__length1 = table_length1;
#line 70 "../lib/util/fuzzy_matching.vala"
				_tmp30__length2 = table_length2;
#line 70 "../lib/util/fuzzy_matching.vala"
				_tmp31_ = _tmp30_[(0 * _tmp30__length2) + (j - 1)];
#line 70 "../lib/util/fuzzy_matching.vala"
				insert_distance = _tmp31_ + insert_cost;
#line 71 "../lib/util/fuzzy_matching.vala"
				if (string_get_char (source, (glong) 0) == string_get_char (target, (glong) j)) {
#line 71 "../lib/util/fuzzy_matching.vala"
					_tmp32_ = 0;
#line 551 "fuzzy_matching.c"
				} else {
#line 71 "../lib/util/fuzzy_matching.vala"
					_tmp32_ = replace_cost;
#line 555 "fuzzy_matching.c"
				}
#line 71 "../lib/util/fuzzy_matching.vala"
				match_distance = (j * insert_cost) + _tmp32_;
#line 72 "../lib/util/fuzzy_matching.vala"
				_tmp33_ = table;
#line 72 "../lib/util/fuzzy_matching.vala"
				_tmp33__length1 = table_length1;
#line 72 "../lib/util/fuzzy_matching.vala"
				_tmp33__length2 = table_length2;
#line 72 "../lib/util/fuzzy_matching.vala"
				_tmp33_[(0 * _tmp33__length2) + j] = MIN (MIN (delete_distance, insert_distance), match_distance);
#line 567 "fuzzy_matching.c"
			}
		}
	}
	{
		gint i = 0;
#line 75 "../lib/util/fuzzy_matching.vala"
		i = 1;
#line 575 "fuzzy_matching.c"
		{
			gboolean _tmp34_ = FALSE;
#line 75 "../lib/util/fuzzy_matching.vala"
			_tmp34_ = TRUE;
#line 75 "../lib/util/fuzzy_matching.vala"
			while (TRUE) {
#line 582 "fuzzy_matching.c"
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_ = 0;
				GeeHashMap* _tmp60_;
#line 75 "../lib/util/fuzzy_matching.vala"
				if (!_tmp34_) {
#line 589 "fuzzy_matching.c"
					gint _tmp35_;
#line 75 "../lib/util/fuzzy_matching.vala"
					_tmp35_ = i;
#line 75 "../lib/util/fuzzy_matching.vala"
					i = _tmp35_ + 1;
#line 595 "fuzzy_matching.c"
				}
#line 75 "../lib/util/fuzzy_matching.vala"
				_tmp34_ = FALSE;
#line 75 "../lib/util/fuzzy_matching.vala"
				_tmp36_ = strlen (source);
#line 75 "../lib/util/fuzzy_matching.vala"
				_tmp37_ = _tmp36_;
#line 75 "../lib/util/fuzzy_matching.vala"
				if (!(i < _tmp37_)) {
#line 75 "../lib/util/fuzzy_matching.vala"
					break;
#line 607 "fuzzy_matching.c"
				}
#line 76 "../lib/util/fuzzy_matching.vala"
				if (string_get_char (source, (glong) i) == string_get_char (target, (glong) 0)) {
#line 76 "../lib/util/fuzzy_matching.vala"
					_tmp38_ = 0;
#line 613 "fuzzy_matching.c"
				} else {
#line 76 "../lib/util/fuzzy_matching.vala"
					_tmp38_ = -1;
#line 617 "fuzzy_matching.c"
				}
#line 76 "../lib/util/fuzzy_matching.vala"
				maxSourceLetterMatchIndex = _tmp38_;
#line 621 "fuzzy_matching.c"
				{
					gint j = 0;
#line 77 "../lib/util/fuzzy_matching.vala"
					j = 1;
#line 626 "fuzzy_matching.c"
					{
						gboolean _tmp39_ = FALSE;
#line 77 "../lib/util/fuzzy_matching.vala"
						_tmp39_ = TRUE;
#line 77 "../lib/util/fuzzy_matching.vala"
						while (TRUE) {
#line 633 "fuzzy_matching.c"
							gint _tmp41_;
							gint _tmp42_;
							GeeHashMap* _tmp43_;
							gpointer _tmp44_;
							gint _tmp45_;
							gint* _tmp46_;
							gint* _tmp47_;
							gint _tmp47__length1;
							gint _tmp47__length2;
							gint _tmp48_;
							gint* _tmp49_;
							gint _tmp49__length1;
							gint _tmp49__length2;
							gint _tmp50_;
							gint* _tmp51_;
							gint _tmp51__length1;
							gint _tmp51__length2;
							gint _tmp52_;
							gboolean _tmp53_ = FALSE;
							gint* _tmp54_;
							gint* _tmp59_;
							gint _tmp59__length1;
							gint _tmp59__length2;
#line 77 "../lib/util/fuzzy_matching.vala"
							if (!_tmp39_) {
#line 659 "fuzzy_matching.c"
								gint _tmp40_;
#line 77 "../lib/util/fuzzy_matching.vala"
								_tmp40_ = j;
#line 77 "../lib/util/fuzzy_matching.vala"
								j = _tmp40_ + 1;
#line 665 "fuzzy_matching.c"
							}
#line 77 "../lib/util/fuzzy_matching.vala"
							_tmp39_ = FALSE;
#line 77 "../lib/util/fuzzy_matching.vala"
							_tmp41_ = strlen (target);
#line 77 "../lib/util/fuzzy_matching.vala"
							_tmp42_ = _tmp41_;
#line 77 "../lib/util/fuzzy_matching.vala"
							if (!(j < _tmp42_)) {
#line 77 "../lib/util/fuzzy_matching.vala"
								break;
#line 677 "fuzzy_matching.c"
							}
#line 78 "../lib/util/fuzzy_matching.vala"
							_tmp43_ = sourceIndexByCharacter;
#line 78 "../lib/util/fuzzy_matching.vala"
							_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp43_, (gpointer) ((gintptr) string_get_char (target, (glong) j)));
#line 78 "../lib/util/fuzzy_matching.vala"
							_tmp45_ = (gint) ((gintptr) _tmp44_);
#line 78 "../lib/util/fuzzy_matching.vala"
							_tmp46_ = __int_dup0 (&_tmp45_);
#line 78 "../lib/util/fuzzy_matching.vala"
							_g_free0 (candidateSwapIndex);
#line 78 "../lib/util/fuzzy_matching.vala"
							candidateSwapIndex = _tmp46_;
#line 79 "../lib/util/fuzzy_matching.vala"
							jSwap = maxSourceLetterMatchIndex;
#line 80 "../lib/util/fuzzy_matching.vala"
							_tmp47_ = table;
#line 80 "../lib/util/fuzzy_matching.vala"
							_tmp47__length1 = table_length1;
#line 80 "../lib/util/fuzzy_matching.vala"
							_tmp47__length2 = table_length2;
#line 80 "../lib/util/fuzzy_matching.vala"
							_tmp48_ = _tmp47_[((i - 1) * _tmp47__length2) + j];
#line 80 "../lib/util/fuzzy_matching.vala"
							delete_distance = _tmp48_ + delete_cost;
#line 81 "../lib/util/fuzzy_matching.vala"
							_tmp49_ = table;
#line 81 "../lib/util/fuzzy_matching.vala"
							_tmp49__length1 = table_length1;
#line 81 "../lib/util/fuzzy_matching.vala"
							_tmp49__length2 = table_length2;
#line 81 "../lib/util/fuzzy_matching.vala"
							_tmp50_ = _tmp49_[(i * _tmp49__length2) + (j - 1)];
#line 81 "../lib/util/fuzzy_matching.vala"
							insert_distance = _tmp50_ + insert_cost;
#line 82 "../lib/util/fuzzy_matching.vala"
							_tmp51_ = table;
#line 82 "../lib/util/fuzzy_matching.vala"
							_tmp51__length1 = table_length1;
#line 82 "../lib/util/fuzzy_matching.vala"
							_tmp51__length2 = table_length2;
#line 82 "../lib/util/fuzzy_matching.vala"
							_tmp52_ = _tmp51_[((i - 1) * _tmp51__length2) + (j - 1)];
#line 82 "../lib/util/fuzzy_matching.vala"
							match_distance = _tmp52_;
#line 84 "../lib/util/fuzzy_matching.vala"
							if (string_get_char (source, (glong) i) != string_get_char (target, (glong) j)) {
#line 85 "../lib/util/fuzzy_matching.vala"
								match_distance += replace_cost;
#line 727 "fuzzy_matching.c"
							} else {
#line 87 "../lib/util/fuzzy_matching.vala"
								maxSourceLetterMatchIndex = j;
#line 731 "fuzzy_matching.c"
							}
#line 89 "../lib/util/fuzzy_matching.vala"
							_tmp54_ = candidateSwapIndex;
#line 89 "../lib/util/fuzzy_matching.vala"
							if (_tmp54_ != NULL) {
#line 89 "../lib/util/fuzzy_matching.vala"
								_tmp53_ = jSwap != -1;
#line 739 "fuzzy_matching.c"
							} else {
#line 89 "../lib/util/fuzzy_matching.vala"
								_tmp53_ = FALSE;
#line 743 "fuzzy_matching.c"
							}
#line 89 "../lib/util/fuzzy_matching.vala"
							if (_tmp53_) {
#line 747 "fuzzy_matching.c"
								gint iSwap = 0;
								gint* _tmp55_;
								gint preswap_cost = 0;
								gboolean _tmp56_ = FALSE;
#line 90 "../lib/util/fuzzy_matching.vala"
								_tmp55_ = candidateSwapIndex;
#line 90 "../lib/util/fuzzy_matching.vala"
								iSwap = *_tmp55_;
#line 92 "../lib/util/fuzzy_matching.vala"
								if (iSwap == 0) {
#line 92 "../lib/util/fuzzy_matching.vala"
									_tmp56_ = jSwap == 0;
#line 760 "fuzzy_matching.c"
								} else {
#line 92 "../lib/util/fuzzy_matching.vala"
									_tmp56_ = FALSE;
#line 764 "fuzzy_matching.c"
								}
#line 92 "../lib/util/fuzzy_matching.vala"
								if (_tmp56_) {
#line 93 "../lib/util/fuzzy_matching.vala"
									preswap_cost = 0;
#line 770 "fuzzy_matching.c"
								} else {
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint _tmp58_;
#line 95 "../lib/util/fuzzy_matching.vala"
									_tmp57_ = table;
#line 95 "../lib/util/fuzzy_matching.vala"
									_tmp57__length1 = table_length1;
#line 95 "../lib/util/fuzzy_matching.vala"
									_tmp57__length2 = table_length2;
#line 95 "../lib/util/fuzzy_matching.vala"
									_tmp58_ = _tmp57_[(MAX (0, iSwap - 1) * _tmp57__length2) + MAX (0, jSwap - 1)];
#line 95 "../lib/util/fuzzy_matching.vala"
									preswap_cost = _tmp58_;
#line 786 "fuzzy_matching.c"
								}
#line 96 "../lib/util/fuzzy_matching.vala"
								swap_distance = ((preswap_cost + (((i - iSwap) - 1) * delete_cost)) + (((j - jSwap) - 1) * insert_cost)) + swap_cost;
#line 790 "fuzzy_matching.c"
							} else {
#line 98 "../lib/util/fuzzy_matching.vala"
								swap_distance = G_MAXINT;
#line 794 "fuzzy_matching.c"
							}
#line 99 "../lib/util/fuzzy_matching.vala"
							_tmp59_ = table;
#line 99 "../lib/util/fuzzy_matching.vala"
							_tmp59__length1 = table_length1;
#line 99 "../lib/util/fuzzy_matching.vala"
							_tmp59__length2 = table_length2;
#line 99 "../lib/util/fuzzy_matching.vala"
							_tmp59_[(i * _tmp59__length2) + j] = MIN (MIN (MIN (delete_distance, insert_distance), match_distance), swap_distance);
#line 804 "fuzzy_matching.c"
						}
					}
				}
#line 101 "../lib/util/fuzzy_matching.vala"
				_tmp60_ = sourceIndexByCharacter;
#line 101 "../lib/util/fuzzy_matching.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp60_, (gpointer) ((gintptr) string_get_char (source, (glong) i)), (gpointer) ((gintptr) i));
#line 812 "fuzzy_matching.c"
			}
		}
	}
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp61_ = table;
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp61__length1 = table_length1;
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp61__length2 = table_length2;
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp62_ = strlen (source);
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp63_ = _tmp62_;
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp64_ = strlen (target);
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp65_ = _tmp64_;
#line 103 "../lib/util/fuzzy_matching.vala"
	_tmp66_ = _tmp61_[((_tmp63_ - 1) * _tmp61__length2) + (_tmp65_ - 1)];
#line 103 "../lib/util/fuzzy_matching.vala"
	result = _tmp66_;
#line 103 "../lib/util/fuzzy_matching.vala"
	_g_object_unref0 (sourceIndexByCharacter);
#line 103 "../lib/util/fuzzy_matching.vala"
	table = (g_free (table), NULL);
#line 103 "../lib/util/fuzzy_matching.vala"
	_g_free0 (candidateSwapIndex);
#line 103 "../lib/util/fuzzy_matching.vala"
	return result;
#line 842 "fuzzy_matching.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

